// ODBCSetupView.cpp : implementation of the CODBCSetupView class
//

#include "stdafx.h"
#include "ODBCSetup.h"
#include "MainFrm.h"

#include <sql.h>
#include <sqlext.h>
#include <odbcinst.h>
#include <string.h>

#include "ODBCSetupDoc.h"
#include "ODBCSetupView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CODBCSetupView

IMPLEMENT_DYNCREATE(CODBCSetupView, CFormView)

BEGIN_MESSAGE_MAP(CODBCSetupView, CFormView)
	//{{AFX_MSG_MAP(CODBCSetupView)
	ON_BN_CLICKED(IDC_INSTALL, OnInstall)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CODBCSetupView construction/destruction

CODBCSetupView::CODBCSetupView()
	: CFormView(CODBCSetupView::IDD)
{
	//{{AFX_DATA_INIT(CODBCSetupView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CODBCSetupView::~CODBCSetupView()
{
}

void CODBCSetupView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CODBCSetupView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CODBCSetupView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CODBCSetupView diagnostics

#ifdef _DEBUG
void CODBCSetupView::AssertValid() const
{
	CFormView::AssertValid();
}

void CODBCSetupView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CODBCSetupDoc* CODBCSetupView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CODBCSetupDoc)));
	return (CODBCSetupDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CODBCSetupView message handlers

void CODBCSetupView::OnCancel() 
{
	( ( CMainFrame * ) GetParent() )->CloseTheApp();
}

BOOL CODBCSetupView::ProcessErrorMessages( char * func )
{
WORD	iError = 1;
DWORD	pfErrorCode;
char	lpszErrorMsg[301];
WORD	cbErrorMsgMax = 300;
WORD	pcbErrorMsg;
int		rc;
BOOL	func_rc = FALSE;

	do
	{
		lpszErrorMsg[0] = '\0';
		rc = SQLInstallerError(
			iError,
			& pfErrorCode,
			lpszErrorMsg,
			cbErrorMsgMax,
			& pcbErrorMsg );
		if( rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO )
		{
			MessageBox( lpszErrorMsg, func );
			func_rc = TRUE;
		}
		iError++;
	}
	while( rc != SQL_NO_DATA );

	return func_rc;
}

void CODBCSetupView::OnInstall() 
{
char	szPath[301];
WORD	cbPathMax = 300;
WORD	cbPathOut;
BOOL	rc = TRUE;

	// First you must copy the driver manager files
	// to the directory returned by SQLInstallDriverManager
	if( SQLInstallDriverManager(
			szPath,
			cbPathMax,
			& cbPathOut ) )
	{
		// Add code HERE to copy the driver manager files

		if( InstallMyTranslator() )
		{
			if( ! IsMyDriverInstalled() )
			{
				rc = InstallMyDriver();
			}
			if( rc )
			{
				AddMyDSN();
			}
		}
	}
	else
		ProcessErrorMessages( "SQLInstallDriverManager" );

	( ( CMainFrame * ) GetParent() )->CloseTheApp();
}

BOOL CODBCSetupView::InstallMyTranslator()
{
char 	szTranslator[300] = "My Bogus Translator\0Translator=MYMSCPXL32.DLL\0";
char 	szPathIn[301];
char	szPathOut[301];
WORD	cbPathOutMax = 300;
WORD	cbPathOut;
DWORD	dwUsageCount;

	// inquire where to install the translator
	SQLInstallTranslatorEx(
			szTranslator,
			NULL,
			szPathIn,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_INQUIRY,
			& dwUsageCount );

	// Add code HERE to copy the translator to lpszPathIn
	// You need to do version checking of translator too

	if( ! SQLInstallTranslatorEx(
			szTranslator,
			szPathIn,
			szPathOut,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_COMPLETE,
			& dwUsageCount ) )
	{
		if( ProcessErrorMessages( "SQLInstallTranslatorEx" ) )
		{
			return FALSE;
		}
	}
	return TRUE;
}

BOOL CODBCSetupView::IsMyDriverInstalled()
{
char	szBuf[2001];
WORD	cbBufMax = 2000;
WORD	cbBufOut;
char *	pszBuf = szBuf;

	if( SQLGetInstalledDrivers(
		szBuf,
		cbBufMax,
		& cbBufOut) )
	{
		if( ProcessErrorMessages( "SQLGetInstalledDrivers" ) )
		{
			( ( CMainFrame * ) GetParent() )->CloseTheApp();
		}
	}
	
	do
	{
		if( strcmp( "My Bogus Driver", pszBuf ) == 0 )
		{
			if( ! BumpUpDriverUsageCount() )
			{
				return FALSE;
			}
			return TRUE;
		}
		pszBuf = strchr( pszBuf, '\0' ) + 1;
	}
	while( pszBuf[1] != '\0' );

	return FALSE;
}

BOOL CODBCSetupView::BumpUpDriverUsageCount()
{
						// the driver keyword pairs have to be valid
						// or you'll get an error
char 	szDriver[300] = "My Bogus Driver\0Driver=mysqlsrv32.dll\0";
char 	szPathIn[301];
char	szPathOut[301];
WORD	cbPathOutMax = 300;
WORD	cbPathOut;
DWORD	dwUsageCount;

	// inquire about the current usage count
	SQLInstallDriverEx(
			szDriver,
			NULL,
			szPathIn,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_INQUIRY,
			& dwUsageCount );

	// You do not have to copy the driver to increment the usage count
	// just increment the usage count
	dwUsageCount++;
	// and pass the value to SQLInstallDriverEx
	if( ! SQLInstallDriverEx(
			szDriver,
			szPathIn,
			szPathOut,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_COMPLETE,
			& dwUsageCount ) )
	{
		if( ProcessErrorMessages( "SQLInstallDriverEx" ) )
		{
			return FALSE;
		}
	}
	return TRUE;
}

BOOL CODBCSetupView::InstallMyDriver()
{
char 	szDriver[300] = "My Bogus Driver\0Driver=mysqlsrv32.dll\0";
char 	szPathIn[301];
char	szPathOut[301];
WORD	cbPathOutMax = 300;
WORD	cbPathOut;
DWORD	dwUsageCount;

	// inquire where to install the driver
	SQLInstallDriverEx(
			szDriver,
			NULL,
			szPathIn,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_INQUIRY,
			& dwUsageCount );

	// Add code HERE to copy the driver to lpszPathIn
	// You need to do version checking of driver too

	if( ! SQLInstallDriverEx(
			szDriver,
			szPathIn,
			szPathOut,
			cbPathOutMax,
			& cbPathOut,
			ODBC_INSTALL_COMPLETE,
			& dwUsageCount ) )
	{
		if( ProcessErrorMessages( "SQLInstallDriverEx" ) )
		{
			return FALSE;
		}
	}
	return TRUE;
}

BOOL CODBCSetupView::AddMyDSN()
{
char	szDriver[300] = "My Bogus Driver";
char	szAttributes[400];

	CreateAttributeString( szAttributes );

	// if one exists just remove it
	SQLConfigDataSource( 
			NULL,
			ODBC_REMOVE_SYS_DSN,
			szDriver, 
			szAttributes );

	// otherwise this call will fail if one exists
	if( ! SQLConfigDataSource(
			NULL,
			ODBC_ADD_SYS_DSN,
			szDriver,
			szAttributes ) )
	{
		if( ProcessErrorMessages( "SQLConfigDataSource" ) )
		{
			return FALSE;
		}
	}
	return TRUE;
}

void CODBCSetupView::CreateAttributeString( char * pszAttributes )
{
char	szName[20] = "My Bogus Translator";
WORD	cbNameMax = 20;
WORD	cbNameOut;
char	szPath[301];
WORD	cbPathMax = 300;
WORD	cbPathOut;
DWORD	vOption;

	SQLGetTranslator(
		this->m_hWnd,
		szName,
		cbNameMax,
		& cbNameOut,
		szPath,
		cbPathMax,
		& cbPathOut,
		& vOption );

	sprintf( pszAttributes, "DSN=Bogus Data Source" );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "Server=rocko" );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "Database=" );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "UID=sa" );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "PWD=" );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "TranslationDLL=%s", szPath );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "TranslationName=%s", szName );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	sprintf( pszAttributes, "TranslationOption=%d\0",vOption );
	pszAttributes = pszAttributes + strlen( pszAttributes ) + 1;
	*pszAttributes = '\0';
}

void CODBCSetupView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	( ( CMainFrame * ) GetParent() )->RecalcLayout( FALSE );
	ResizeParentToFit( FALSE );
}
